Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7549)
@@ -1025,6 +1025,4 @@
         ticket.code = course.code
         ticket.title = course.title
-        ticket.faculty = course.__parent__.__parent__.__parent__.title
-        ticket.department = course.__parent__.__parent__.title
         ticket.fcode = course.__parent__.__parent__.__parent__.code
         ticket.dcode = course.__parent__.__parent__.code
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/courseticketmanagepage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/courseticketmanagepage.pt	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/courseticketmanagepage.pt	(revision 7549)
@@ -17,5 +17,5 @@
         </td>
         <td>
-            <span tal:replace="context/faculty">FACULTY</span>
+            <span tal:replace="context/fcode">FACULTY</span>
         </td>
       </tr>
@@ -25,5 +25,5 @@
         </td>
         <td>
-            <span tal:replace="context/department">DEPARTMENT</span>
+            <span tal:replace="context/dcode">DEPARTMENT</span>
         </td>
       </tr>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/courseticketpage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/courseticketpage.pt	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/courseticketpage.pt	(revision 7549)
@@ -14,5 +14,5 @@
       </td>
       <td>
-          <span tal:replace="context/department">DEPARTMENT</span>
+          <span tal:replace="context/dcode">DEPARTMENT</span>
       </td>
     </tr>
@@ -22,5 +22,5 @@
       </td>
       <td>
-          <span tal:replace="context/faculty">FACULTY</span>
+          <span tal:replace="context/fcode">FACULTY</span>
       </td>
     </tr>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studyleveleditpage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studyleveleditpage.pt	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studyleveleditpage.pt	(revision 7549)
@@ -28,6 +28,6 @@
       </a></td>
       <td tal:content="value/title">TITLE</td>
-      <td tal:content="value/department">DEPARTMENT</td>
-      <td tal:content="value/faculty">FACULTY</td>
+      <td tal:content="value/dcode">DEPARTMENT</td>
+      <td tal:content="value/fcode">FACULTY</td>
       <td tal:content="value/credits">CREDITS</td>
       <td tal:content="value/score">SCORE</td>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelmanagepage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelmanagepage.pt	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelmanagepage.pt	(revision 7549)
@@ -69,6 +69,6 @@
           </a></td>
           <td tal:content="value/title">TITLE</td>
-          <td tal:content="value/department">DEPARTMENT</td>
-          <td tal:content="value/faculty">FACULTY</td>
+          <td tal:content="value/dcode">DEPARTMENT</td>
+          <td tal:content="value/fcode">FACULTY</td>
           <td tal:content="value/credits">CREDITS</td>
           <td tal:content="value/core_or_elective">MANDATORY</td>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt	(revision 7549)
@@ -49,6 +49,6 @@
       </a></td>
       <td tal:content="value/title">TITLE</td>
-      <td tal:content="value/department">DEPARTMENT</td>
-      <td tal:content="value/faculty">FACULTY</td>
+      <td tal:content="value/dcode">DEPARTMENT</td>
+      <td tal:content="value/fcode">FACULTY</td>
       <td tal:content="value/credits">CREDITS</td>
       <td tal:content="value/core_or_elective">MANDATORY</td>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7549)
@@ -336,6 +336,4 @@
     passmark = Attribute('passmark of the original course')
     semester = Attribute('semester of the original course')
-    faculty = Attribute('faculty of the original course')
-    department = Attribute('department of the original course')
     fcode = Attribute('faculty code of the original course')
     dcode = Attribute('department code of the original course')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py	(revision 7548)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py	(revision 7549)
@@ -90,6 +90,4 @@
         self.code = None
         self.title = None
-        self.faculty = None
-        self.department = None
         self.fcode = None
         self.dcode = None