Index: /main/waeup.custom/trunk/src/waeup/custom/ftesting.zcml
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/ftesting.zcml	(revision 7585)
+++ /main/waeup.custom/trunk/src/waeup/custom/ftesting.zcml	(revision 7586)
@@ -1,4 +1,5 @@
 <configure
    xmlns="http://namespaces.zope.org/zope"
+   xmlns:sirp="http://namespaces.waeup.org/sirp"
    i18n_domain="waeup.custom"
    package="waeup.custom"
@@ -8,4 +9,8 @@
   <includeOverrides package="waeup.custom" />
   <includeOverrides package="waeup.custom" file="mail.zcml"/>
+
+  <!-- Where should the datacenter reside by default? -->
+  <sirp:datacenter
+      path="../../../parts/test/datacenter" />
 
   <!-- Typical functional testing security setup -->
Index: /main/waeup.custom/trunk/src/waeup/custom/tests/test_datacenter.py
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/tests/test_datacenter.py	(revision 7586)
+++ /main/waeup.custom/trunk/src/waeup/custom/tests/test_datacenter.py	(revision 7586)
@@ -0,0 +1,30 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+from waeup.sirp.datacenter import DataCenter
+from waeup.sirp.testing import FunctionalTestCase
+from waeup.custom.testing import FunctionalLayer
+
+
+class DatacenterTests(FunctionalTestCase):
+
+    layer = FunctionalLayer
+
+    def test_storage_path(self):
+        mydatacenter = DataCenter()
+        storagepath = mydatacenter.storage
+        self.assertTrue('/parts/test/datacenter' in storagepath)
Index: /main/waeup.custom/trunk/src/waeup/custom/utils/tests.py
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/utils/tests.py	(revision 7585)
+++ /main/waeup.custom/trunk/src/waeup/custom/utils/tests.py	(revision 7586)
@@ -1,3 +1,3 @@
-## $Id: tests.py$
+## $Id$
 ##
 ## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
@@ -16,5 +16,4 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
-from waeup.sirp.datacenter import DataCenter
 from waeup.sirp.testing import FunctionalTestCase
 from waeup.custom.testing import FunctionalLayer
@@ -25,6 +24,6 @@
     layer = FunctionalLayer
 
-    def test_storage_path(self):
-        mydatacenter = DataCenter()
-        storagepath = mydatacenter.storage
-        self.assertTrue('/src/waeup/custom/files' in storagepath)
+    def test_foo(self):
+        '''Test method foo.
+        '''
+        return
Index: /main/waeup.custom/trunk/src/waeup/custom/utils/utils.py
===================================================================
--- /main/waeup.custom/trunk/src/waeup/custom/utils/utils.py	(revision 7585)
+++ /main/waeup.custom/trunk/src/waeup/custom/utils/utils.py	(revision 7586)
@@ -16,5 +16,5 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
-"""General helper utilities for SIRP.
+"""Customize general helper utilities for SIRP.
 """
 import os
@@ -25,8 +25,2 @@
     """A collection of methods subject to customization.
     """
-
-    def storage(self):
-        """Return the initial storage path of the data center.
-        """
-        return os.path.dirname(__file__).replace('utils','files')
-