Index: main/waeup.sirp/trunk/README.txt
===================================================================
--- main/waeup.sirp/trunk/README.txt	(revision 7588)
+++ main/waeup.sirp/trunk/README.txt	(revision 7589)
@@ -1,6 +1,6 @@
-What is `waeup.sirp`?
-*********************
+What is WAeUP.SIRP ?
+********************
 
-The WAeUP Student Information and Registration Portal. `waeup.sirp` is
+The WAeUP Student Information and Registration Portal (WAeUP.SIRP) is
 a web-based management tool for managing universities and schools.
 
Index: main/waeup.sirp/trunk/docs/INSTALL.txt
===================================================================
--- main/waeup.sirp/trunk/docs/INSTALL.txt	(revision 7588)
+++ main/waeup.sirp/trunk/docs/INSTALL.txt	(revision 7589)
@@ -2,6 +2,6 @@
 ***************************************
 
-.. note:: `waeup.sirp` might not work with Python > 2.6
-          currently. Use of Python 2.6 is recommended.
+.. note:: `waeup.sirp` might not work with Python > 2.7
+          currently. Use of Python 2.6 or 2.7 is recommended.
 
 Prerequisites
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/api_university.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/api_university.rst	(revision 7588)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/api_university.rst	(revision 7589)
@@ -22,9 +22,9 @@
    university/api_vocabularies
    university/api_batching
-   university/api_facultycontainer
+   university/api_facultiescontainer
    university/api_faculty
    university/api_department
-   university/api_certificatecontainer
-   university/api_coursecontainer
+   university/api_certificatescontainer
+   university/api_coursescontainer
    university/api_course
    university/api_certificate
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/api_users.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/api_users.rst	(revision 7588)
+++ 	(revision )
@@ -1,6 +1,0 @@
-`users` -- Users (Principals) Module
-************************************
-
-.. automodule:: waeup.sirp.users
-   :members:
-   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/api_userscontainer.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/api_userscontainer.rst	(revision 7589)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/api_userscontainer.rst	(revision 7589)
@@ -0,0 +1,6 @@
+`userscontainer` -- Users (Principals) Module
+*********************************************
+
+.. automodule:: waeup.sirp.userscontainer
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_interfaces.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_interfaces.rst	(revision 7588)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/applicants/api_interfaces.rst	(revision 7589)
@@ -5,7 +5,4 @@
    :members:
    :undoc-members:
-
-   .. autointerface:: IResultEntry
-      :members:
 
    .. autointerface:: IApplicantsRoot
@@ -27,20 +24,8 @@
       :members:
 
-   .. autointerface:: IResultEntry
+   .. autointerface:: IApplicantUpdateByRegNo
       :members:
 
-   .. autointerface:: IApplicantPrincipalInfo
-      :members:
-
-   .. autointerface:: IApplicantPrincipal
-      :members:
-
-   .. autointerface:: IApplicantPrincipal
-      :members:
-
-   .. autointerface:: IApplicantsFormChallenger
-      :members:
-
-   .. autointerface:: IApplicantSessionCredentials
+   .. autointerface:: IApplicantOnlinePayment
       :members:
 
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7588)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7589)
@@ -20,5 +20,5 @@
    api_datacenter
    api_imagestorage
-   api_users
+   api_userscontainer
    api_workflow
    api_university
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_certificatecontainer.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_certificatecontainer.rst	(revision 7588)
+++ 	(revision )
@@ -1,6 +1,0 @@
-`university.certificatecontainer` - Certificate Container Components
-********************************************************************
-
-.. automodule:: waeup.sirp.university.certificatecontainer
-   :members:
-   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_certificatescontainer.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_certificatescontainer.rst	(revision 7589)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_certificatescontainer.rst	(revision 7589)
@@ -0,0 +1,6 @@
+`university.certificatescontainer` - Certificates Container Components
+**********************************************************************
+
+.. automodule:: waeup.sirp.university.certificatescontainer
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_coursecontainer.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_coursecontainer.rst	(revision 7588)
+++ 	(revision )
@@ -1,6 +1,0 @@
-`university.coursecontainer` - Course Container Components
-**********************************************************
-
-.. automodule:: waeup.sirp.university.coursecontainer
-   :members:
-   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_coursescontainer.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_coursescontainer.rst	(revision 7589)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_coursescontainer.rst	(revision 7589)
@@ -0,0 +1,6 @@
+`university.coursescontainer` - Courses Container Components
+************************************************************
+
+.. automodule:: waeup.sirp.university.coursescontainer
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_facultiescontainer.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_facultiescontainer.rst	(revision 7589)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_facultiescontainer.rst	(revision 7589)
@@ -0,0 +1,6 @@
+`university.facultiescontainer` - Faculties Container Components
+****************************************************************
+
+.. automodule:: waeup.sirp.university.facultiescontainer
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_facultycontainer.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_facultycontainer.rst	(revision 7588)
+++ 	(revision )
@@ -1,6 +1,0 @@
-`university.facultycontainer` - Faculty Container Components
-************************************************************
-
-.. automodule:: waeup.sirp.university.facultycontainer
-   :members:
-   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_interfaces.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_interfaces.rst	(revision 7588)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/university/api_interfaces.rst	(revision 7589)
@@ -12,5 +12,5 @@
    :members:
 
-.. autointerface:: waeup.sirp.university.interfaces.IFacultyContainer
+.. autointerface:: waeup.sirp.university.interfaces.IFacultiesContainer
    :members:
 
@@ -21,5 +21,5 @@
    :members:
 
-.. autointerface:: waeup.sirp.university.interfaces.ICourseContainer
+.. autointerface:: waeup.sirp.university.interfaces.ICoursesContainer
    :members:
 
@@ -36,5 +36,5 @@
    :members:
 
-.. autointerface:: waeup.sirp.university.interfaces.ICertificateContainer
+.. autointerface:: waeup.sirp.university.interfaces.ICertificatesContainer
    :members:
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/showstudentspage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/showstudentspage.pt	(revision 7588)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/showstudentspage.pt	(revision 7589)
@@ -10,5 +10,5 @@
   </thead>
   <tbody>
-	<tr tal:repeat="item view/getStudents">
+	<tr tal:repeat="item view/getStudents" class="gradeC">
 	  <td> <a tal:attributes="href item/url"
             target="_blank">