Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7592)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7593)
@@ -23,4 +23,5 @@
    api_workflow
    api_university
+   api_students
    api_browser
    api_applicants
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_accommodation.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_accommodation.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_accommodation.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.accommodation` - Student Accommodation Components
+***********************************************************
+
+.. automodule:: waeup.sirp.students.accommodation
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_authentication.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_authentication.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_authentication.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.authentication` - Student Authentication Components
+*************************************************************
+
+.. automodule:: waeup.sirp.students.authentication
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_batching.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_batching.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_batching.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.batching` - Student Import and Export Components
+**********************************************************
+
+.. automodule:: waeup.sirp.students.batching
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_browser.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_browser.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_browser.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.browser` - Students UI Components
+*******************************************
+
+.. automodule:: waeup.sirp.students.browser
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_catalog.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_catalog.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_catalog.rst	(revision 7593)
@@ -0,0 +1,8 @@
+`students.catalog` - Students Catalog Components
+************************************************
+
+.. automodule:: waeup.sirp.students.catalog
+   :members:
+   :undoc-members:
+
+   .. class:: StudentIndexes
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_container.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_container.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_container.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.container` - Students Container
+*****************************************
+
+.. automodule:: waeup.sirp.students.container
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_dynamicroles.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_dynamicroles.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_dynamicroles.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.dynamicroles` - Dynamic Roles Components
+**************************************************
+
+.. automodule:: waeup.sirp.students.dynamicroles
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_interfaces.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_interfaces.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_interfaces.rst	(revision 7593)
@@ -0,0 +1,60 @@
+`students.interfaces` - Students Related Interfaces
+***************************************************
+
+.. automodule:: waeup.sirp.students.interfaces
+   :members:
+   :undoc-members:
+
+   .. autointerface:: IStudentsUtils
+      :members:
+
+   .. autointerface:: IStudentsContainer
+      :members:
+
+   .. autointerface:: IStudentNavigation
+      :members:
+
+   .. autointerface:: IStudentBase
+      :members:
+
+   .. autointerface:: IStudentClearance
+      :members:
+
+   .. autointerface:: IStudentPersonal
+      :members:
+
+   .. autointerface:: IStudent
+      :members:
+
+   .. autointerface:: IStudentUpdateByRegNo
+      :members:
+
+   .. autointerface:: IStudentUpdateByMatricNo
+      :members:
+
+   .. autointerface:: IStudentStudyCourse
+      :members:
+
+   .. autointerface:: IStudentStudyLevel
+      :members:
+
+   .. autointerface:: ICourseTicket
+      :members:
+
+   .. autointerface:: ICourseTicketAdd
+      :members:
+
+   .. autointerface:: IStudentAccommodation
+      :members:
+
+   .. autointerface:: IBedTicket
+      :members:
+
+   .. autointerface:: IStudentPaymentsContainer
+      :members:
+
+   .. autointerface:: IStudentOnlinePayment
+      :members:
+
+   .. autointerface:: IStudentChangePassword
+      :members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_payments.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_payments.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_payments.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.payments` - Student Payments
+**************************************
+
+.. automodule:: waeup.sirp.students.payments
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_permissions.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_permissions.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_permissions.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.permissions` - Student Permissions
+********************************************
+
+.. automodule:: waeup.sirp.students.permissions
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_student.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_student.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_student.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.student` - Student Components
+***************************************
+
+.. automodule:: waeup.sirp.students.student
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_studycourse.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_studycourse.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_studycourse.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.studycourse` - Student Study Course Components
+********************************************************
+
+.. automodule:: waeup.sirp.students.studycourse
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_studylevel.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_studylevel.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_studylevel.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.studylevel` - Student Study Level Components
+******************************************************
+
+.. automodule:: waeup.sirp.students.studylevel
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_utils.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_utils.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_utils.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.utils` - Student Utilities
+************************************
+
+.. automodule:: waeup.sirp.students.utils
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_viewlets.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_viewlets.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_viewlets.rst	(revision 7593)
@@ -0,0 +1,11 @@
+`students.viewlets` - Student Browser Viewlets
+**********************************************
+
+Probably due to a bug in Sphinx autodoc couldn't import/find some classes and
+reported error: "grokcore, please check your spelling and sys.path".
+Thus, automodule has been temporarily disabled.
+
+..
+  .. automodule:: waeup.sirp.students.viewlets
+     :members:
+     :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_vocabularies.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_vocabularies.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_vocabularies.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.vocabularies` - Student Vocabularies
+**********************************************
+
+.. automodule:: waeup.sirp.students.vocabularies
+   :members:
+   :undoc-members:
Index: main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_workflow.rst
===================================================================
--- main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_workflow.rst	(revision 7593)
+++ main/waeup.sirp/trunk/docs/source/developerdocs/api/students/api_workflow.rst	(revision 7593)
@@ -0,0 +1,6 @@
+`students.workflow` - Student Workflow
+**************************************
+
+.. automodule:: waeup.sirp.students.workflow
+   :members:
+   :undoc-members: