Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_payments.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_payments.rst	(revision 7595)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_payments.rst	(revision 7595)
@@ -0,0 +1,23 @@
+`payments` -- Payment Components Package
+****************************************
+
+(see also: :ref:`api-payments-modules`)
+
+.. automodule:: waeup.sirp.payments
+   :members:
+   :undoc-members:
+
+.. _api-payments-modules:
+
+Submodules
+----------
+
+This package bundles the following modules:
+
+.. toctree::
+   :maxdepth: 1
+
+   payments/api_payment
+   payments/api_container
+   payments/api_vocabularies
+   payments/api_interfaces
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7594)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7595)
@@ -13,19 +13,19 @@
    :maxdepth: 1
 
+   api_accesscodes
    api_app
+   api_applicants
+   api_authentication
+   api_browser
+   api_catalog
+   api_datacenter
+   api_hostels
+   api_imagestorage
    api_interfaces
-   api_authentication
-   api_catalog
+   api_payments
    api_permissions
-   api_datacenter
-   api_imagestorage
+   api_university
    api_userscontainer
+   api_utils
+   api_students
    api_workflow
-   api_university
-   api_students
-   api_browser
-   api_applicants
-   api_accesscodes
-   api_hostels
-   api_utils
-
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_container.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_container.rst	(revision 7595)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_container.rst	(revision 7595)
@@ -0,0 +1,6 @@
+`payments.container` - Payments Container Components
+****************************************************
+
+.. automodule:: waeup.sirp.payments.container
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_interfaces.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_interfaces.rst	(revision 7595)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_interfaces.rst	(revision 7595)
@@ -0,0 +1,18 @@
+`payments.interfaces` - Payment Interfaces
+******************************************
+
+.. automodule:: waeup.sirp.payments.interfaces
+   :members:
+   :undoc-members:
+
+   .. autointerface:: IPaymentsContainer
+      :members:
+
+   .. autointerface:: IPayment
+      :members:
+
+   .. autointerface:: ISCPayment
+      :members:
+
+   .. autointerface:: IOnlinePayment
+      :members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_payment.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_payment.rst	(revision 7595)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_payment.rst	(revision 7595)
@@ -0,0 +1,6 @@
+`payments.payment` - Payment Components
+***************************************
+
+.. automodule:: waeup.sirp.payments.payment
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_vocabularies.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_vocabularies.rst	(revision 7595)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/payments/api_vocabularies.rst	(revision 7595)
@@ -0,0 +1,6 @@
+`payments.vocabularies` - Payment Vocabularies
+**********************************************
+
+.. automodule:: waeup.sirp.payments.vocabularies
+   :members:
+   :undoc-members: