Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_schema.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_schema.rst	(revision 7598)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_schema.rst	(revision 7598)
@@ -0,0 +1,21 @@
+`schema` -- Schema Fields
+*************************
+
+(see also: :ref:`api-schema-modules`)
+
+.. automodule:: waeup.sirp.utils
+   :members:
+   :undoc-members:
+
+.. _api-schema-modules:
+
+Submodules
+----------
+
+This package bundles the following modules:
+
+.. toctree::
+   :maxdepth: 1
+
+   schema/api_field
+
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_widgets.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_widgets.rst	(revision 7598)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/api_widgets.rst	(revision 7598)
@@ -0,0 +1,23 @@
+`widgets` -- Widgets
+********************
+
+(see also: :ref:`api-widgets-modules`)
+
+.. automodule:: waeup.sirp.widgets
+   :members:
+   :undoc-members:
+
+.. _api-widgets-modules:
+
+Submodules
+----------
+
+This package bundles the following modules:
+
+.. toctree::
+   :maxdepth: 1
+
+   widgets/api_datewidget
+   widgets/api_phonewidget
+   widgets/api_restwidget
+   widgets/api_objectwidget
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7597)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/index.rst	(revision 7598)
@@ -25,7 +25,9 @@
    api_payments
    api_permissions
+   api_schema
    api_university
    api_userscontainer
    api_utils
    api_students
+   api_widgets
    api_workflow
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/schema/api_field.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/schema/api_field.rst	(revision 7598)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/schema/api_field.rst	(revision 7598)
@@ -0,0 +1,6 @@
+`schema.field` - Special Fields
+*******************************
+
+.. automodule:: waeup.sirp.schema.field
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_datewidget.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_datewidget.rst	(revision 7598)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_datewidget.rst	(revision 7598)
@@ -0,0 +1,6 @@
+`widgets.datewidget` - Date Widget
+**********************************
+
+.. automodule:: waeup.sirp.widgets.datewidget
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_objectwidget.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_objectwidget.rst	(revision 7598)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_objectwidget.rst	(revision 7598)
@@ -0,0 +1,6 @@
+`widgets.objectwidget` - Object Widget
+**************************************
+
+.. automodule:: waeup.sirp.widgets.objectwidget
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_phonewidget.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_phonewidget.rst	(revision 7598)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_phonewidget.rst	(revision 7598)
@@ -0,0 +1,6 @@
+`widgets.phonewidget` - Phone Widget
+************************************
+
+.. automodule:: waeup.sirp.widgets.phonewidget
+   :members:
+   :undoc-members:
Index: /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_restwidget.rst
===================================================================
--- /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_restwidget.rst	(revision 7598)
+++ /main/waeup.sirp/trunk/docs/source/developerdocs/api/widgets/api_restwidget.rst	(revision 7598)
@@ -0,0 +1,6 @@
+`widgets.restwidget` - ReST Widget
+**********************************
+
+.. automodule:: waeup.sirp.widgets.restwidget
+   :members:
+   :undoc-members: