Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7619)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7620)
@@ -17,6 +17,8 @@
 ##
 from datetime import datetime
+from zope.component import getUtility
 from zope.interface import Attribute, Interface
 from zope import schema
+from zc.sourcefactory.contextual import BasicContextualSourceFactory
 from waeup.sirp.interfaces import (
     ISIRPObject, academic_sessions_vocab, validate_email)
@@ -24,9 +26,25 @@
 from waeup.sirp.university.vocabularies import CourseSource, study_modes
 from waeup.sirp.students.vocabularies import (
-  CertificateSource, VerdictSource, StudyLevelSource,
+  CertificateSource, StudyLevelSource,
   contextual_reg_num_source, contextual_mat_num_source,
   GenderSource, nats_vocab,
   )
 from waeup.sirp.payments.interfaces import IPaymentsContainer, IOnlinePayment
+
+# VerdictSource can't be placed into the vocabularies module because it
+# requires importing IStudentsUtils which then leads to circular imports.
+class VerdictSource(BasicContextualSourceFactory):
+    """A verdicts source delivers all verdicts provided
+    in the portal.
+    """
+    def getValues(self, context):
+        self.verdicts_dict = getUtility(IStudentsUtils).getVerdictsDict()
+        return self.verdicts_dict.keys()
+
+    def getToken(self, context, value):
+        return value
+
+    def getTitle(self, context, value):
+        return self.verdicts_dict[value]
 
 class IStudentsUtils(Interface):
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/utils.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/utils.py	(revision 7619)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/utils.py	(revision 7620)
@@ -338,2 +338,34 @@
             'Content-Type', 'application/pdf')
         return pdf.getpdfdata()
+
+    def getVerdictsDict(self):
+        """Provide a dictionary of verdicts.
+        """
+        return {
+            'A1': 'First Class',
+            '0': 'not yet',
+            'A3': 'Second Class Lower',
+            'A2': 'Second Class Upper',
+            'A5': 'Pass',
+            'A4': 'Third Class',
+            'A7': 'Credit',
+            'A6': 'Distinction',
+            'A8': 'Merit',
+            'A': 'Successful student',
+            'C': 'Student on probation',
+            'B': 'Student with carryover courses',
+            'E': 'Student who were previously on probation',
+            'D': 'Withdrawn from the faculty',
+            'G': 'Absent from examination',
+            'F': 'Medical case',
+            'I': 'Expelled/rusticated/suspended student',
+            'H': 'Withheld results',
+            'K': 'Unregistered student',
+            'J': 'Temporary withdrawn from the university',
+            'M': 'Reinstatement',
+            'L': 'Referred student',
+            'O': 'NCE-III repeater',
+            'N': 'Student on transfer',
+            'Y': 'No previous verdict',
+            'X': 'New 300 level student',
+            'Z': 'Successful student (provisional)'}
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py	(revision 7619)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py	(revision 7620)
@@ -25,5 +25,5 @@
 from zc.sourcefactory.basic import BasicSourceFactory
 from zc.sourcefactory.contextual import BasicContextualSourceFactory
-from waeup.sirp.interfaces import SimpleSIRPVocabulary, ISIRPUtils
+from waeup.sirp.interfaces import SimpleSIRPVocabulary
 from waeup.sirp.students.lgas import LGAS
 from waeup.sirp.students.nats import NATS
@@ -85,19 +85,4 @@
             return "%s on %d. probation" % (title, repeat)
         return title
-
-class VerdictSource(BasicContextualSourceFactory):
-    """A verdicts source delivers all verdicts provided
-    in the portal.
-    """
-
-    def getValues(self, context):
-        self.verdicts_dict = getUtility(ISIRPUtils).getVerdictsDict()
-        return self.verdicts_dict.keys()
-
-    def getToken(self, context, value):
-        return value
-
-    def getTitle(self, context, value):
-        return self.verdicts_dict[value]
 
 class CertificateSource(BasicContextualSourceFactory):