Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7641)
@@ -590,5 +590,5 @@
     @property
     def current_mode(self):
-        if self.context.certificate:
+        if self.context.certificate is not None:
             current_mode = study_modes.getTermByToken(
                 self.context.certificate.study_mode).title
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containermanagepage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containermanagepage.pt	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containermanagepage.pt	(revision 7641)
@@ -11,4 +11,5 @@
     <option value="current_session">in session</option>
     <option value="depcode">in department</option>
+    <option value="current_mode">in study mode</option>
   </select>
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containerpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containerpage.pt	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containerpage.pt	(revision 7641)
@@ -11,4 +11,5 @@
     <option value="current_session">in session</option>
     <option value="depcode">in department</option>
+    <option value="current_mode">in study mode</option>
   </select>
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/catalog.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/catalog.py	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/catalog.py	(revision 7641)
@@ -47,4 +47,5 @@
     faccode = index.Field(attribute='faccode')
     current_session = index.Field(attribute='current_session')
+    current_mode = index.Field(attribute='current_mode')
 
 class StudentQueryResultItem(object):
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 7641)
@@ -134,4 +134,5 @@
     faccode = Attribute('The faculty code of any chosen study course')
     current_session = Attribute('The current session of the student')
+    current_mode = Attribute('The current mode of the student')
     fullname = Attribute('All name parts separated by hyphens')
     display_fullname = Attribute('The fullname of an applicant')
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/student.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/student.py	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/student.py	(revision 7641)
@@ -111,6 +111,13 @@
     @property
     def current_session(self):
-        cert = getattr(self.get('studycourse', None), 'current_session', None)
-        return cert
+        session = getattr(self.get('studycourse', None), 'current_session', None)
+        return session
+
+    @property
+    def current_mode(self):
+        certificate = getattr(self.get('studycourse', None), 'certificate', None)
+        if certificate is not None:
+            return certificate.study_mode
+        return
 
 # Set all attributes of Student required in IStudent as field
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7641)
@@ -271,4 +271,18 @@
         self.browser.getControl(name="searchtype").value = ['student_id']
         self.browser.getControl(name="searchterm").value = self.student_id
+        self.browser.getControl("Search").click()
+        self.assertTrue('Anna Tester' in self.browser.contents)
+
+        # We can find a student in a certain session
+        self.browser.open(self.container_path)
+        self.browser.getControl(name="searchtype").value = ['current_session']
+        self.browser.getControl(name="searchterm").value = '2004'
+        self.browser.getControl("Search").click()
+        self.assertTrue('Anna Tester' in self.browser.contents)
+
+        # We can find a student in a certain study_mode
+        self.browser.open(self.container_path)
+        self.browser.getControl(name="searchtype").value = ['current_mode']
+        self.browser.getControl(name="searchterm").value = 'ug_ft'
         self.browser.getControl("Search").click()
         self.assertTrue('Anna Tester' in self.browser.contents)
@@ -598,4 +612,5 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.assertEqual(self.browser.url, self.studycourse_student_path)
+        self.assertTrue('Undergraduate Full Time' in self.browser.contents)
         self.browser.getLink("Manage").click()
         self.assertTrue('Manage study course' in self.browser.contents)
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/catalog.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/catalog.py	(revision 7640)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/catalog.py	(revision 7641)
@@ -56,5 +56,5 @@
 class CertificateCoursesIndexes(grok.Indexes):
     """This catalog is needed for automatic removal of certificate courses
-    and later for selection course tickets in the students section.
+    and later for selection of course tickets in the students section.
     """
     grok.site(IUniversity)
@@ -67,5 +67,5 @@
 @grok.subscribe(ICourse, grok.IObjectAddedEvent)
 def handle_course_added(obj, event):
-    """Index an added course with the local catalog.
+    """Index an add course with the local catalog.
 
     Courses are not indexed automatically, as they are not a