Index: main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/accesscode.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/accesscode.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/accesscode.py	(revision 7649)
@@ -572,5 +572,4 @@
         return None, u'No AC batch available.'
     rand_num = list(batch.getNewRandomNum())[0]
-    #import pdb; pdb.set_trace()
     num = len(batch) + 1
     batch.addAccessCode(num, rand_num, owner)
Index: main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/accesscodes/browser.py	(revision 7649)
@@ -144,5 +144,4 @@
         else:
             return
-        #import pdb; pdb.set_trace()
         if not 'entries' in form:
             self.hitlist = search(query=self.searchterm,
Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7649)
@@ -424,5 +424,4 @@
     def test_after_login_default_browsable(self):
         # After login we see the placeholder image in the edit view
-        #import pdb; pdb.set_trace()
         self.login()
         self.assertEqual(self.browser.url, self.view_path)
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 7649)
@@ -194,5 +194,4 @@
             elif widget.__class__.__name__ == 'IntWidget':
                 widget.cssClass = 'span2'
-        #import pdb; pdb.set_trace()
         if self.widgets.get('title'):
             self.widgets['title'].cssClass = 'span12'
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/batching.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/batching.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/batching.py	(revision 7649)
@@ -459,5 +459,4 @@
         elif 'reg_number' in row.keys() and row['reg_number']:
             reg_number = row['reg_number']
-            #import pdb; pdb.set_trace()
             cat = queryUtility(ICatalog, name='students_catalog')
             results = list(
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_batching.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_batching.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_batching.py	(revision 7649)
@@ -531,5 +531,4 @@
         self.assertEqual(courseticket.passmark, 40)
         self.assertEqual(courseticket.semester, 1)
-        #import pdb; pdb.set_trace()
         shutil.rmtree(os.path.dirname(fin_file))
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 7649)
@@ -1282,5 +1282,4 @@
           Paid
         </td>...'''
-        #import pdb; pdb.set_trace()
         self.assertMatches(expected,self.browser.contents)
         # The new CLR-0 pin has been created
Index: main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.py	(revision 7649)
@@ -303,5 +303,5 @@
                 # student_ids and applicant_ids which have been
                 # generated in the respective __init__ methods before.
-                self.updateEntry(obj, row, site) 
+                self.updateEntry(obj, row, site)
                 try:
                     self.addEntry(obj, row, site)
Index: main/waeup.sirp/trunk/src/waeup/sirp/utils/tests/test_converters.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/utils/tests/test_converters.py	(revision 7648)
+++ main/waeup.sirp/trunk/src/waeup/sirp/utils/tests/test_converters.py	(revision 7649)
@@ -255,5 +255,4 @@
         err, inv_err, data = converter.fromStringDict(
             dict(birthday='1945-23-12'), contact)
-        #import pdb; pdb.set_trace()
         #assert data['birthday'] == datetime.date(1945, 12, 23)
         assert err[0][1] =='Invalid datetime data'